% Get the camera information
a = imaqhwinfo;
camera_name = char(a.InstalledAdaptors(end));
camera_info = imaqhwinfo(camera_name);
camera_id = camera_info.DeviceInfo.DeviceID(end);
resolution = char(camera_info.DeviceInfo.SupportedFormats(end));
% Capture the video frames using the videoinput function
% You have to replace the resolution & your installed adaptor name.
vid = videoinput(camera_name, camera_id,'YUY2_320X240' );
%vid=videoinput('winvideo',1,'YUY2_640X480');

% Set the properties of the video object
set(vid, 'FramesPerTrigger', Inf);
set(vid, 'ReturnedColorspace', 'rgb');
vid.FrameGrabInterval = 2; % Get one of every two frames

%start the video aquisition here
%start(vid)

k = 1;
% define k depending on your need (how many minutes are you going to use
% the virtual mouse?)
while k < 10;
    %start the video aquisition here
    start(vid)
    k = k+1;
% Set a loop to stop the video when the memory is full
while(vid.FramesAcquired<=450)
    
    % Get the snapshot of the current frame
    vid_frame = getsnapshot(vid);
    % subtract the blue component 
    % from the grayscale image to extract the blue components in the image.
    diff_im = imsubtract(vid_frame(:,:,3), rgb2gray(vid_frame));
    imshow(diff_im);
    %Use a median filter to filter out noise
    diff_im = medfilt2(diff_im, [3 3]);
    % Convert the resulting grayscale image into a binary image.
    diff_im = im2bw(diff_im,0.1);
    
    % Remove all those pixels less than 300 pixels
    diff_im = bwareaopen(diff_im,300);
    
    % Label all the connected components in the image.
    bw = bwlabel(diff_im, 8);
    
    % Here we do the image blob analysis.
    % We get a set of properties for each labeled region.
    stats = regionprops(bw, 'BoundingBox', 'Centroid');
    
    % Display the image
    imshow(vid_frame);
    number_of_object = length(stats);
    hold on
    
    %This is a loop to bound the red objects in a rectangular box.
   for  object = 1:number_of_object
        bb = stats(object).BoundingBox;
        bc = stats(object).Centroid;
        rectangle('Position',bb,'EdgeColor','r','LineWidth',2)
        plot(bc(1),bc(2), '-m+');
        a=text(bc(1)+15,bc(2), strcat('X: ', num2str(round(bc(1))), '    Y: ', num2str(round(bc(2)))));
        set(a, 'FontName', 'Arial', 'FontWeight', 'bold', 'FontSize', 12, 'Color', 'yellow');
        %set(0,'PointerLocation',[bc(1) bc(2)]);
        
        % if there is only one object then move the cursor depending on the
        % object center
        if number_of_object == 1
            import java.awt.Robot; 
            import java.awt.event.*; 
            mouse = Robot; 
            mouse.mouseMove(6*bc(1)-400, 5.56*bc(2)-333);
        end
        
   end 
    %if there are two objects then click the left button of the mouse
        
        if number_of_object == 2
           %import java.awt.Robot;
           %import java.awt.event.*;
           %mouse = Robot;
           mouse.mousePress(InputEvent.BUTTON1_MASK);           
           mouse.mouseRelease(InputEvent.BUTTON1_MASK);
           %mouse.mouseMove(4*bc(1)-400, 3.33*bc(2)-333);
           % Get a new sample from the video
           pause(.5)
           vid_frame = getsnapshot(vid);
           diff_im = imsubtract(vid_frame(:,:,3), rgb2gray(vid_frame));
           diff_im = medfilt2(diff_im, [3 3]);
           diff_im = im2bw(diff_im,0.15);
           diff_im = bwareaopen(diff_im,300);
           bw = bwlabel(diff_im, 8);    
           stats = regionprops(bw, 'BoundingBox', 'Centroid');
           number_of_object = length(stats);     
           % still there are two object or not
                if number_of_object == 2
                    %import java.awt.Robot;
                    %import java.awt.event.*;
                    %mouse = Robot;
                    mouse.mousePress(InputEvent.BUTTON1_MASK);
                    %pause(.5);
                    mouse.mouseRelease(InputEvent.BUTTON1_MASK);
                    %mouse.mouseMove(4*bc(1)-400, 3.33*bc(2)-333);
           
                end
        end
             %Delay
        %pause(.75);
    
        
        %if there are there objects then click the right button of the mouse
         if number_of_object == 3
           %Delay
           pause(1);
           %import java.awt.Robot;
           %import java.awt.event.*;
           %mouse = Robot;
           mouse.mousePress(InputEvent.BUTTON3_MASK);
           %Delay
           %pause(0.5);
           mouse.mouseRelease(InputEvent.BUTTON3_MASK);
           
        end
    hold off
end

% Stop the video aquisition.
stop(vid);

% Flush all the image data stored in the memory buffer.
flushdata(vid);
end
% Clear all variables
stop(vid);
flushdata(vid);
clear all
sprintf('%s','Virtual Mouse is offline ')
